package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20020ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.ResponsibleUserInfoBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot20048ReqUserInfo extends ProtBase {

	private final short iTaskCode20048 = 20048;
	// private String jsonData;
	// private String sInspectorId;
	private Gson gson;
	private Prot20020ResBean resBean;
	private List<ResponsibleUserInfoBean> userInfos = new ArrayList<>();
	private boolean isEnd = false;//true：所有协议包已经请求完      false：服务器返回的数据还未接收完全

	public Prot20048ReqUserInfo() {
		// this.sInspectorId = sInspectorId;
		gson = new Gson();
	}

	public Prot20020ResBean getUserInfo() {
		return this.resBean;
	}

	public void dealUserInfoList(SocketCreate create) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis());
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode20048, "开始请求用户信息");
				sendProt(dos);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
				}
			}
		}
	}

	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20048, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20048, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot20020ResBean.class);
			
			if (resBean.getUser() != null) {
				userInfos.addAll(resBean.getUser());
			}
			if (resBean.getIndex() == 0) {
				//所有协议包已经请求完
				resBean.setUser(userInfos);
				isEnd = true;
			}
			if (resBean.getResult() == 1) {
				//请求时遇到错误信息
				isEnd = true;
			}
		} else {
			isEnd = true;
		}

		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos) throws IOException {
//		String bodyContent = gson.toJson(productBean).toString();
		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20048, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
